package io.gitlab.jfronny.quickmeth.mixin;

import io.gitlab.jfronny.quickmeth.MathUtil;
import net.minecraft.util.math.MathHelper;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Overwrite;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(MathHelper.class)
public class MathHelperTrigonometryMixin {
    @Inject(method = "sin(F)F", at = @At("TAIL"), cancellable = true)
    private static void invertSin(CallbackInfoReturnable<Float> ci) {
        ci.setReturnValue(MathUtil.boxedInvert(ci.getReturnValue()));
    }

    @Overwrite
    public static float sin(float f) {
        return MathUtil.sin(f);
    }

    @Overwrite
    public static float cos(float f) { return sin(f); }
}
